#ifndef _IMQERR_HPP_
#define _IMQERR_HPP_

//  Library:       MQSeries
//  Component:     IMQI (MQSeries C++ MQI)
//  Part:          IMQERR.HPP
//
//  Description:   "ImqError" class declaration
//
//  Statement:     Licensed Materials - Property of IBM                          
//                                                               
//                 84H2000, 5765-B73                                   
//                 84H2001, 5639-B42                                   
//                 84H2002, 5765-B74                                   
//                 84H2003, 5765-B75                                   
//                 84H2004, 5639-B43                                   
//                 (C) Copyright IBM Corp. 1994, 1997                       
//
//                 U.S. Government Users Restricted Rights -
//                 use, duplication or disclosure restricted by
//                 GSA ADP Schedule Contract with IBM Corp.

extern "C" {
#include <cmqc.h>
#include <imqtype.h>
#include <string.h>
}

#define ImqError ImqErr

class ImqObj ;
class ImqPmo ;
class ImqError {
  MQLONG olCompletionCode ;
  MQLONG olReasonCode ;
protected :
  friend class ImqObj ;
  friend class ImqPmo ;
  // New methods:
  ImqBoolean checkReadPointer ( const void *, const size_t );
  ImqBoolean checkWritePointer ( const void *, const size_t );
  void setCompletionCode ( const MQLONG lCode = 0 )
    { olCompletionCode = lCode ; }
  void setReasonCode ( const MQLONG lCode = 0 ) { olReasonCode = lCode ; }
public :
  // New methods:
  ImqError ( );
  ImqError ( const ImqError & );
  virtual ~ ImqError ( );
  void operator = ( const ImqError & );
  void clearErrorCodes ( );
  MQLONG completionCode ( ) const { return olCompletionCode ; }
  MQLONG reasonCode ( ) const { return olReasonCode ; }
} ;

#endif
