#ifndef _IMQHDR_HPP_
#define _IMQHDR_HPP_

//  Library:       MQSeries
//  Component:     IMQI (MQSeries C++ MQI)
//  Part:          IMQHDR.HPP
//
//  Description:   "ImqHeader" class declaration
//
//  Statement:     Licensed Materials - Property of IBM                          
//                                                               
//                 84H2000, 5765-B73                                   
//                 84H2001, 5639-B42                                   
//                 84H2002, 5765-B74                                   
//                 84H2003, 5765-B75                                   
//                 84H2004, 5639-B43                                   
//                 (C) Copyright IBM Corp. 1994, 1997                       
//
//                 U.S. Government Users Restricted Rights -
//                 use, duplication or disclosure restricted by
//                 GSA ADP Schedule Contract with IBM Corp.

#include <imqstr.hpp> // ImqString

#define ImqHeader ImqHdr

class ImqHeader : public ImqItem {
public :
  // New methods:
  ImqHeader ( );
  ImqHeader ( const ImqHeader & );
  virtual ~ ImqHeader ( );
  void operator = ( const ImqHeader & );
  virtual MQLONG characterSet ( ) const = 0 ;
  virtual MQLONG encoding ( ) const = 0 ;
  virtual ImqString format ( ) const = 0 ;
  virtual MQLONG headerFlags ( ) const = 0 ;
  virtual void setCharacterSet ( const MQLONG = MQCCSI_Q_MGR ) = 0 ;
  virtual void setEncoding ( const MQLONG = MQENC_NATIVE ) = 0 ;
  virtual void setFormat ( const char * = 0 ) = 0 ;
  virtual void setHeaderFlags ( const MQLONG = 0 ) = 0 ;
} ;

#endif
